% ------------------------------------------------
% Autor: P. Adrian Roig Ortiz
% Mster Ingeniera Acstica
% Asunto: Trabajo final de Mster, Estudio de la influencia del pblico en los subgraves en espectculos al aire libre.
% Fecha de entrega: Septiembre 2013
% Fichero:cdigo de simulacin, fdtd3daudiencia
% --------------------------------------------------
function fdtd3d_audiencia(file,audience,dp,df,row1)
%file=folder name
%audience=1 includes the audience. Otherwise the audience is not included.
%dp= distancia entre personas de una misma fila / distance between people
%in the same row.
%df= distancia entre las filas / distance between rows.
%1->distance=lambda,   2->distance=lambda/2,  0->distance=lambda/4,  3->minimum
%separation, 4->bloque/block,  5-> Free (manual)
%row1= distance between stage and frontline audience.
%1->distance=lambda,   2->distance=lambda/2,  0->distance=lambda/4,  3->minimum.

close all

%%%%%
maxttt=60;%maxttt=number of main steps  120
maxtt=23;  %maxtt=number of calculation steps in each main step (20 for a good video)
centralfrequency=100;%centralfrequency= central frequency of the excitation
%%%%%

if nargin<5
    disp('Not enough inputs expecified')
    return
end
if length(dir(file))<1
    eval(['! md ' file]);
end
%===================
% Variable
%===================
%dimensiones recinto/room dimensions
spacex=18;spacey=12;spacez=7;
%mallado & inicializacin de variables/meshing and variable initialization
dh=0.1;
nx=round(spacex/dh);ny=round(spacey/dh);nz=round(spacez/dh);
[y,x,z]     =   meshgrid((1:ny)*dh,(1:nx)*dh,(1:nz)*dh);
[yux,xux]   =   meshgrid((1:ny)*dh,(1:nx+1)*dh-dh/2);
[yuy,xuy]   =   meshgrid((1:ny+1)*dh-dh/2,(1:nx)*dh);


p=zeros(nx,ny,nz);ux=zeros(nx+1,ny,nz);uy=zeros(nx,ny+1,nz);uz=zeros(nx,ny,nz+1);
px=p*0;py=p*0;pz=p*0;p=p*0;

minx=min(min(min(x)));maxx=max(max(max(x)));meanx=(maxx+minx)/2;
miny=min(min(min(y)));maxy=max(max(max(y)));meany=(maxy+miny)/2;
minz=min(min(min(z)));maxz=max(max(max(z)));meanz=(maxz+minz)/2;

%posiciones micro
%micro tcnico->h1
micTec_x=round(15/dh);
micTec_y1=round(9/dh); micTec_y2=round(meany/dh); micTec_y3=round(2.5/dh);
micTec_z1=round(1.70/dh); micTec_z2=round(1.35/dh);
%micro escenario->h2
micStg_x=round(1.8/dh);
micStg_y1=micTec_y1; micStg_y2=micTec_y2; micStg_y3=micTec_y3;
micStg_z1=micTec_z1+round(2/dh);%1.70m + 2m de escenario
%micro medio->h3
micMid_x=round(meanx/dh);
micMid_y1=micTec_y1; micMid_y2=micTec_y2; micMid_y3=micTec_y3;
micMid_z1=round(1.70/dh); micMid_z2=round(1.35/dh);

if audience==1
    
    %===================
    % Coordenadas publico
    %===================
    lambda=341/100;%c/f   para 100Hz
    %definicin de la zona audiencia
    switch row1%determinamos la posicin de la primera persona de la primera fila.
        case 1
            disp('Distancia a la primera fila= lambda')
            pos1x=2+lambda;
        case 2
            disp('Distancia a la primera fila= lambda/2')
            pos1x=2+lambda/2;
        case 0
            disp('Distancia a la primera fila= lambda/4')
            pos1x=2+lambda/4;
        case 3
            disp('Distancia a la primera fila= 1.5m (mnima)')
            pos1x=3.5;
        otherwise
            disp('error en el parmetro de entrada de coeficiente ROW1. Tomare distancia mnima')
            pos1x=3.5;
    end
    
    pos1y=1.5;%primera posicin y (fila 1)
    pos1Finx=pos1x;pos1Finy= maxy-1.5;%ultima posicin fila 1.
    
    posFin1x=13;     posFin1y=pos1y;%persona ms abajo en la ltima fila
    posFinFinx=posFin1x;  posFinFiny=pos1Finy;%persona arriba, ltima fila.
    %segundo calculamos en nmero de personas que caben en la zona de audiencia
    switch dp
        case 1
            disp('Distancia entre personas= lambda')
            coeficienteP=lambda;
        case 2
            disp('Distancia entre personas= lambda/2')
            coeficienteP=lambda/2;
        case 0
            disp('Distancia entre personas= lambda/4')
            coeficienteP=lambda/4;
        case 3
            disp('Distancia entre personas=0.1m (mnima)')
            coeficienteP=0.1;
        case 4
            disp('Distancia entre personas=0 (pegadas)')
            coeficienteP=-0.1;
        otherwise
            disp('error en el parmetro de entrada de coeficiente. Tomare distancia lambda/4')
            coeficienteP=lambda/4;
    end
    
    switch df
        case 1
            disp('Distancia entre filas= lambda')
            coeficienteF=lambda;
        case 2
            disp('Distancia entre filas= lambda/2')
            coeficienteF=lambda/2;
        case 0
            disp('Distancia entre filas= lambda/4')
            coeficienteF=lambda/4;
        case 3
            disp('Distancia entre filas=0.1m (mnima)')
            coeficienteF=-0.3;
        case 4
            disp('Distancia entre filas=0 (pegadas)')
            coeficienteF=-0.4;
        otherwise
            disp('error en el parmetro de entrada de coeficiente. Tomare distancia lambda/4')
            coeficienteF=lambda/4;
    end
    
    %ahora calcula el nmero de personas por fila
    ancho=0.6;%ancho hombros de las personas
    nmaxPersonas=round((pos1Finy-pos1y)/(coeficienteP+ancho));
    disp(['Caben ' num2str(nmaxPersonas) ' personas por fila.'])
    %calculamos en nmero de filas
    nmaxFilas=round((posFin1x-pos1x)/(coeficienteF+ancho));
    disp(['Caben ' num2str(nmaxFilas) ' filas de pblico.'])
    %Calculamos los centros
    puntosx=zeros(nmaxPersonas,nmaxFilas); puntosy=zeros(nmaxPersonas,nmaxFilas);
    puntosx(:,1)=pos1x; puntosy(1,:)=pos1y;
    contenedorx=pos1x;
    contenedory=pos1y;
    
    for ii=2:nmaxFilas
        contenedorx=contenedorx+ coeficienteF+ancho;
        puntosx(:,ii)=contenedorx;
    end
    for ii=2:nmaxPersonas
        contenedory=contenedory+coeficienteP+ancho;
        puntosy(ii,:)=contenedory;
    end
    
    
    %===================
    % Coloca humanos
    %===================
    home=hombre3d;%Aqu se hace un individuo y me quedo con los numeros de fila y columna que construyen el hombre(find).
    [xlista,ylista,zlista] = ind2sub(size(home),find(home == 1));
    % xcoordenadashombres=round([3,3,3]/dh);
    % ycoordenadashombres=round([1,2,3]/dh);
    xcoordenadashombres=round(puntosx(:)/dh);
    ycoordenadashombres=round(puntosy(:)/dh);
    zcoordenadashombres=zeros(nmaxPersonas,nmaxFilas);
    mapaz=p;
    for ii=1:length(xcoordenadashombres)
        mapaz(xlista+xcoordenadashombres(ii)+(ylista+ycoordenadashombres(ii)-1)*nx + (zlista-1)*nx*ny)=1;
    end
    %==fin ColocaHumanos
    
    %==================================
    % Busqueda de los puntos de contorno
    %==================================
    listap0=find(mapaz==1);
    mip=p;
    mip(listap0)=1;
    
    %Bsqueda de puntos de ux que son contorno
    [i,jj]=find(diff(mip)==1); j=mod(jj-1,ny)+1; k=(jj-j)/ny+1;
    uxz=(i+1)+(j-1)*(nx+1)+(k-1)*(nx+1)*ny;
    pxz=  i  +(j-1)*  nx  +(k-1)*  nx  *ny;
    signoux=ones(length(i),1)';
    [i,jj]=find(diff(mip)==-1); j=mod(jj-1,ny)+1; k=(jj-j)/ny+1;
    uxz=[uxz.' ((i+1)+(j-1)*(nx+1)+(k-1)*(nx+1)*ny).'].';
    pxz=[pxz.' ((i+1)+(j-1)*  nx  +(k-1)*  nx  *ny).'].';
    signoux=[signoux -ones(length(i),1)'];
    
    %Bsqueda de puntos de uy que son contorno
    [i,jj]=find(diff(mip,1,2)==1); j=mod(jj-1,ny-1)+1; k=1+(jj-j)/(ny-1);
    uyz=i+(j  )*nx+(k-1)*nx*(ny+1);
    pyz=i+(j-1)*nx+(k-1)*nx* ny;
    signouy=ones(length(i),1)';
    [i,jj]=find(diff(mip,1,2)==-1); j=mod(jj-1,ny-1)+1; k=1+(jj-j)/(ny-1);
    uyz=[uyz.' (i+ (j) * nx+(k-1)*nx*(ny+1)).'].';
    pyz=[pyz.' (i+(j)* nx+(k-1)*nx*  ny ).'].';
    signouy=[signouy -ones(length(i),1)'];
    
    %Bsqueda de puntos de uz que son contorno
    [i,jj]=find(diff(mip,1,3)==+1); j=mod(jj-1,ny)+1;k=1+(jj-j)/ny;
    uzz=(i+(j-1)*nx+(k)*nx*ny);
    pzz=(i+(j-1)*nx+(k-1)*nx*ny);
    signouz=ones(length(i),1)';
    [i,jj]=find(diff(mip,1,3)==-1); j=mod(jj-1,ny)+1;k=1+(jj-j)/ny;
    uzz=[uzz.' (i+(j-1)*nx+(k)*nx*ny).'].';
    pzz=[pzz.' (i+(j-1)*nx+(k)*nx*ny).'].';
    signouz=[signouz -ones(length(i),1)'];
else
    pos1x=1.2; pos1y=1.5;
end%if audience

%==================================
%PML
%==================================
lengthPML=15;
alfamax=.5;

alfax=zeros(nx,ny,nz);alfay=zeros(nx,ny,nz);
for ii=1:nz;
    alfax(1:lengthPML,:,ii)=      repmat(alfamax*[((lengthPML:-1:1)/lengthPML).^2]',1,ny);
    alfax(1+end-lengthPML:end,:,ii)=repmat(alfamax*[((1:1:lengthPML)/lengthPML).^2]',1,ny);
    alfay(:,1:lengthPML,ii)=      repmat(alfamax*[((lengthPML:-1:1)/lengthPML).^2],nx,1);
    alfay(:,1+end-lengthPML:end,ii)=repmat(alfamax*[((1:1:lengthPML)/lengthPML).^2],nx,1);
end
alfaux=(alfax(1:end-1,:,:)+alfax(2:end,:,:))/2;
alfauy=(alfay(:,1:end-1,:)+alfay(:,2:end,:))/2;

for ii=1:nx;
    for jj=1:ny;
        for kk=1:lengthPML;
            %alfaz(ii,jj,kk)=alfamax*((lengthPML+1-kk)/lengthPML).^2;%PML suelo
            alfaz(ii,jj,nz+1-kk)=alfamax*((lengthPML+1-kk)/lengthPML).^2;
        end
    end
end

alfauz=(alfaz(:,:,1:end-1)+alfaz(:,:,2:end))/2;
%finPML

%===================
%media constants
%===================
rho=1.21;c=341;k=(c^2)*rho;
dt=dh/c/3;
impedance=1;% impedancia normalizada de los muros.
impedance2=10;% impedancia normalizada de las personas.  alfa=0.32  Znorm=4.2927e+003/413
disp(['Maxima frecuencia bien simulada ' num2str(round(c/(dh*10)*1000)/1000) ' Hz']);
disp(['La simulacin contendr ' num2str(round(maxtt*maxttt*1000*dt)) ' ms.'])

%===================
%excitation
%===================
%senoidal
%     centralfrequency=100;
%     t=((1:maxtt*maxttt)*dt);
%     w=(1-exp(-t*centralfrequency/2)).*sin(2*pi*t*centralfrequency);
%riker
%
a=centralfrequency/(sqrt(pi)/2)*8;
t=((1:maxtt*maxttt)/(1/dt)-8/a);
amplitud=7;
w=-amplitud*(exp(-a^2*(t.^2)/2).*(a^2*(t.^2)-1));

%perfil gaussiana
%     gaussiana=((z(1,:,:)-meanz).^2+(y(1,:,:)-meany).^2); %perfil de la excitacin gaussiana
% figure; plot(t,w,t(1:maxtt:end),w(1:maxtt:end),'or'); pause(2);close

%===================
%Calculations
%===================
source_x=round(2/dh);
for ttt=1:maxttt;
    for tt=1:maxtt;
        %preassure calculation
        
        px=px.*(1-alfax)-k*dt/dh*diff(ux,1,1);
        py=py.*(1-alfay)-k*dt/dh*diff(uy,1,2);
        pz=pz.*(1-alfaz)-k*dt/dh*diff(uz,1,3);
        
        px(source_x,round(5.5/dh):round(6.5/dh),1:round(0.9/dh))=w(tt+maxtt*(ttt-1));%acoustic source
        py(source_x,round(5.5/dh):round(6.5/dh),1:round(0.9/dh))=w(tt+maxtt*(ttt-1));%MODELO DE PISTN ACSTICO
        pz(source_x,round(5.5/dh):round(6.5/dh),1:round(0.9/dh))=w(tt+maxtt*(ttt-1));
        p=px+py+pz;
        %velocity calculation
        ux(2:nx,:,:)=ux(2:nx,:,:).*(1-alfaux)-dt/rho/dh*diff(p,1,1);%diff(1,1)resta el elemento de una fila con el de la otro fila (fila superior (final-inicial : abajo-arriba)
        uy(:,2:ny,:)=uy(:,2:ny,:).*(1-alfauy)-dt/rho/dh*diff(p,1,2);%diff(1,2)resta el elemento de una columna con el de su lado (columna anterior)
        uz(:,:,2:nz)=uz(:,:,2:nz).*(1-alfauz)-dt/rho/dh*diff(p,1,3);
        %boundary conditions
        ux(1,:,:)  =-p(1,:,:)    /rho/c/impedance;
        ux(end,:,:)= p(end,:,:)  /rho/c/impedance;
        uy(:,1,:)  =-p(:,1,:)    /rho/c/impedance;
        uy(:,end,:)= p(:,end,:)  /rho/c/impedance;
        uz(:,:,1)  =-0*p(:,:,1)    /rho/c/impedance; %SUELO
        uz(:,:,end)= p(:,:,end)  /rho/c/impedance;
        %-----Stage
        uy(1:round(2/dh),round(2/dh),1:round(2/dh))=0;%lateral 1
        uy(1:round(2/dh),round(10/dh),1:round(2/dh))=0;%lateral 2
        ux(round(2/dh),round(2/dh):round(5.5/dh),1:round(2/dh))=0;%frontal hasta lado izq del subwoofer
        ux(round(2/dh),round(6.5/dh):round(10/dh),1:round(2/dh))=0;%frontal desde lado derecho del subwoofer
        ux(round(2/dh),round(2/dh):round(10/dh),round(0.9/dh):round(2/dh))=0;%arriba del subwoofer
        uz(1:round(2/dh),round(2/dh):round(10/dh),1:round(2/dh))=0;%superior caja
        
        %-----Public
        if audience
            ux(uxz)=signoux.*p(pxz.')/rho/c/impedance2;
            uy(uyz)=signouy.*p(pyz.')/rho/c/impedance2;
            uz(uzz)=signouz.*p(pzz.')/rho/c/impedance2;
          
        end
        %recording
        %zona tecnico
        micTec_1_up(tt+maxtt*(ttt-1))=p(round(micTec_x),round(micTec_y1),round(micTec_z1));
        micTec_1_st(tt+maxtt*(ttt-1))=p(round(micTec_x),round(micTec_y1),round(micTec_z2));
        micTec_2_up(tt+maxtt*(ttt-1))=p(round(micTec_x),round(micTec_y2),round(micTec_z1));
        micTec_2_st(tt+maxtt*(ttt-1))=p(round(micTec_x),round(micTec_y2),round(micTec_z2));
        micTec_3_up(tt+maxtt*(ttt-1))=p(round(micTec_x),round(micTec_y3),round(micTec_z1));
        micTec_3_st(tt+maxtt*(ttt-1))=p(round(micTec_x),round(micTec_y3),round(micTec_z2));
        %escenario
        micStg_1_up(tt+maxtt*(ttt-1))=p(round(micStg_x),round(micStg_y1),round(micStg_z1));
        micStg_2_up(tt+maxtt*(ttt-1))=p(round(micStg_x),round(micStg_y2),round(micStg_z1));
        micStg_3_up(tt+maxtt*(ttt-1))=p(round(micStg_x),round(micStg_y3),round(micStg_z1));
        
        %medio
        micMid_1_up(tt+maxtt*(ttt-1))=p(round(micMid_x),round(micMid_y1),round(micMid_z1));
        micMid_1_st(tt+maxtt*(ttt-1))=p(round(micMid_x),round(micMid_y1),round(micMid_z2));
        micMid_2_up(tt+maxtt*(ttt-1))=p(round(micMid_x),round(micMid_y2),round(micMid_z1));
        micMid_2_st(tt+maxtt*(ttt-1))=p(round(micMid_x),round(micMid_y2),round(micMid_z2));
        micMid_3_up(tt+maxtt*(ttt-1))=p(round(micMid_x),round(micMid_y3),round(micMid_z1));
        micMid_3_st(tt+maxtt*(ttt-1))=p(round(micMid_x),round(micMid_y3),round(micMid_z2));
        
        
        
    end
    disp(['listos ' num2str(ttt) ' pasos de ' num2str(maxttt)]);
    pp=p;
    if audience
        pp(listap0)=1;%Color publico
    end
    pp(1:round(2/dh),round(2/dh):round(10/dh),1:round(2/dh))=20;%color escenario.
    
    pp1= pp(:,:,micTec_z1);
    pp2= pp(:,:,micTec_z2);
    pp3=pp(:,:,1);  %esto servir para representar el plano X vs Y en la altura de la posicion Z=0m (suelo);
    pp4=squeeze(pp(:,micTec_y2,:));%perfil izquierdo Y eje central.
    pp5=squeeze(pp(:,round(pos1y/dh)+2,:));%perfil izquierdo Y del primer espectador
    pp6=squeeze(pp(micStg_x,:,:));
    pp7=squeeze(pp(micMid_x,:,:));
    pp8=squeeze(pp(micTec_x,:,:));
    pp9=squeeze(pp(source_x+2,:,:));
    
    pp1(1,1)=1;
    pp1=min(max(pp1.^2,1d-3),1);
    pp2(1,1)=1;
    %pinta mics
        pp2(micTec_x,:)=1;
        pp2(micMid_x,:)=1;
        pp2(:,micStg_y1)=1;
        pp2(:,micStg_y2)=1;
        pp2(:,micStg_y3)=1;
    pp2=min(max(pp2.^2,1d-3),1);
    pp3(1,1)=1;
    pp3=min(max(pp3.^2,1d-3),1);
    pp4(1,1)=1;
    pp4=min(max(pp4.^2,1d-3),1);
    pp5(1,1)=1;
    pp5=min(max(pp5.^2,1d-3),1);
    pp6(1,1)=1;
    pp6=min(max(pp6.^2,1d-3),1);
    pp7(1,1)=1;
    pp7=min(max(pp7.^2,1d-3),1);
    pp8(1,1)=1;
    pp8=min(max(pp8.^2,1d-3),1);
    pp9(1,1)=1;
    pp9=min(max(pp9.^2,1d-3),1);
    
%     figure(1)
    subplot(3,3,1)
    pcolor(x(:,:,1)',y(:,:,1)',10*log10(pp1'));shading flat,axis equal;colorbar;title('vistas PLANTA');drawnow
    subplot(3,3,4)
    pcolor(x(:,:,1)',y(:,:,1)',10*log10(pp2'));shading flat,axis equal;colorbar;drawnow
    subplot(3,3,7)
    pcolor(x(:,:,1)',y(:,:,1)',10*log10(pp3'));shading flat,axis equal;colorbar;title('Suelo');drawnow
    subplot(3,3,2)
    pcolor(squeeze(x(:,1,:))',squeeze(z(:,1,:))',10*log10(pp4'));shading flat,axis equal;colorbar;title(['Perfil. y= ' num2str(micTec_y2*dh)]);drawnow
    subplot(3,3,5)
    pcolor(squeeze(x(:,1,:))',squeeze(z(:,1,:))',10*log10(pp5'));shading flat,axis equal;colorbar;title(['Perfil. y= ' num2str((round(pos1y/dh)+2)*dh)]);drawnow
    subplot(3,3,8)
    pcolor(squeeze(y(1,:,:))',squeeze(z(1,:,:))',10*log10(pp9'));shading flat,axis equal;colorbar;title(['time=' num2str(round((tt+maxtt*(ttt-1))*1000*dt)) ' miliseconds']);drawnow
    subplot(3,3,3)
    pcolor(squeeze(y(1,:,:))',squeeze(z(1,:,:))',10*log10(pp6'));shading flat,axis equal; colorbar;colorbar;title(['corte en x=' num2str(micStg_x*dh)]);drawnow
    subplot(3,3,6)
    pcolor(squeeze(y(1,:,:))',squeeze(z(1,:,:))',10*log10(pp7'));shading flat,axis equal; colorbar;colorbar;title(['corte en x=' num2str(micMid_x*dh)]);drawnow
    subplot(3,3,9)
    pcolor(squeeze(y(1,:,:))',squeeze(z(1,:,:))',10*log10(pp8'));shading flat,axis equal; colorbar;colorbar;title(['corte en x=' num2str(micTec_x*dh)]);drawnow
end
beep;pause(1);beep;pause(1);beep;pause(1);
save(['.\' file '\listmic'],'w','dt','source_x','micTec_x','micStg_x','micMid_x',...
    'micTec_1_up','micTec_1_st','micTec_2_up','micTec_2_st', ...
    'micTec_3_up','micTec_3_st','micStg_1_up','micStg_2_up','micStg_3_up',...
    'micMid_1_up','micMid_1_st','micMid_2_up','micMid_2_st','micMid_3_up','micMid_3_st')
if audience==1
    save(['.\' file '\mapaz'],'mapaz')
    beep;pause(1);
end
beep;pause(1);beep;pause(1)
